#include "poirot.h"
#include <stdio.h>

#define TRUE 1
#define FALSE 0

int pendingIo;
int stopFlag;
int stopEvent;
int stopped;

void dec(void)
{
  int pio;

  POIROT_ATOMIC (
    pendingIo = pendingIo - 1;
    pio = pendingIo;
  )

  if(pio==0)
  {
    stopEvent = 1;
  }
}

int inc(void)
{
  int status;

  POIROT_ATOMIC (
    pendingIo = pendingIo + 1
  )

  if(stopFlag)
  {
    dec();
    status = 0;
  }
  else
  {
    status = 1;
  }

  return status;
}

int stopper(void)
{
  stopFlag = TRUE;
  dec();
  __hv_assume(stopEvent);
  stopped = TRUE;
  return 0;
}

int adder1(void) {
  int status;

  status = inc();
  if(status>0)
  {
    POIROT_ASSERT(!stopped);
    /* Perform IO */
  }

  dec();
  
  return 0;
}

int adder2(void) {
  int status;

  status = inc();
  if(status>0)
  {
    POIROT_ASSERT(!stopped);
    /* Perform IO */
  }

  dec();
  
  return 0;
}

void main(void) {
  int th_1, th_2, th_3;
  
  pendingIo = 1;
  stopFlag = FALSE;
  stopEvent = FALSE;
  stopped = FALSE;
  
  __async_call th_1 = adder1();
  __async_call th_2 = adder2();
  __async_call th_3 = stopper();
}
