#!/bin/bash

echo "Running Esbmc on examples:"

# Non-terminating runs commented out

# CORRECT EXAMPLES

echo "  Account Good"
(time esbmc account_good.c  --unwind 13 --z3-ir) > esbmc_logs/account_good.log 2>&1
echo "    .. Done"

#echo "  BigNum Good"
#(time esbmc bignum_good.c  --unwind 51) > esbmc_logs/bignum_good.log 2>&1
#echo "    .. Done"

#echo "  Bluetooth 3a"
#(time esbmc bluetooth3a.c --unwind 36) > esbmc_logs/bluetooth3a.log 2>&1
#echo "    .. Done"

echo "  Token Ring"
(time esbmc tokenring_good.c --unwind 7) > esbmc_logs/tokenring_good.log 2>&1
echo "    .. Done"

# BUGGY EXAMPLES

echo "  Account Bad"
(time esbmc account_bad.c  --unwind 13 --z3-ir) > esbmc_logs/account_bad.log 2>&1
echo "    .. Done"

echo "  BigNum Bad"
(time esbmc bignum_bad.c --unwind 51 --no-unwinding-assertions) > esbmc_logs/bignum_bad.log 2>&1
echo "    .. Done"

echo "  Bluetooth 1"
(time esbmc bluetooth1.c --unwind 3 --no-unwinding-assertions) > esbmc_logs/bluetooth1.log 2>&1
echo "    .. Done"

echo "  Bluetooth 2"
(time esbmc bluetooth2.c --unwind 5 --no-unwinding-assertions) > esbmc_logs/bluetooth2.log 2>&1
echo "    .. Done"

echo "  Bluetooth 3b"
(time esbmc bluetooth3b.c --unwind 4 --no-unwinding-assertions) > esbmc_logs/bluetooth3b.log 2>&1
echo "    .. Done"

echo "  Infinite Loop Bug 1"
(time esbmc infloop_bug1.c --unwind 1 --no-unwinding-assertions) > esbmc_logs/infloop_bug1.log 2>&1
echo "    .. Done"

echo "  Infinite Loop Bug 2"
(time esbmc infloop_bug2.c --unwind 2 --no-unwinding-assertions) > esbmc_logs/infloop_bug2.log 2>&1
echo "    .. Done"

echo "  Token Ring Bad"
(time esbmc tokenring_bad.c --unwind 7) > esbmc_logs/tokenring_bad.log	2>&1
echo "    .. Done"
